SystemOrganization addCategory: #'Magritte-VisualWorks'!

VW5PackageExporter subclass: #MAVisualWorksExporter
	instanceVariableNames: ''
	classVariableNames: 'PrefixRegistry ObjectRegistry'
	poolDictionaries: ''
	category: 'Magritte-VisualWorks'!

!MAVisualWorksExporter class methodsFor: 'initialization' stamp: 'lr 2/9/2006 13:15'!
initialize
	ObjectRegistry := Dictionary new
		at: 'ProtoObject' put: '';
		at: 'Object' put: 'Squeak.Object';
		at: 'TestCase' put: 'XProgramming.SUnit.TestCase';
		at: 'TestResource' put: 'XProgramming.SUnit.TestResource';
		at: 'TestSuite' put: 'XProgramming.SUnit.TestSuite';
		at: 'SmaCCScanner' put: 'Refactory.SmaCC.SmaCCScanner';
		at: 'SmaCCParser' put: 'Refactory.SmaCC.SmaCCParser';
		yourself.
	PrefixRegistry := Dictionary new
		at: 'WA' put: 'Seaside';
		at: 'MA' put: 'Magritte';
		at: 'SW2' put: 'SmallWiki2';
		yourself.! !

!MAVisualWorksExporter methodsFor: 'accessing' stamp: 'lr 11/15/2005 20:41'!
environment
	^ super environment copyUpTo: $-.! !

!MAVisualWorksExporter methodsFor: 'file-out' stamp: 'lr 11/15/2005 20:19'!
fileOutClassCommentForClass: aClass
	aClass hasComment ifFalse: [ ^ self ].
	self tag: 'comment' do: [
		self tag: 'class-id' with: (self fullyQualifiedClassNameFor: aClass).
		self tag: 'body' with: aClass comment asString ].! !

!MAVisualWorksExporter methodsFor: 'file-out' stamp: 'lr 11/15/2005 20:20'!
fileOutClassDefinition: aClass
	super fileOutClassDefinition: aClass.
	self fileOutClassCommentForClass: aClass.! !

!MAVisualWorksExporter methodsFor: 'file-out' stamp: 'lr 11/15/2005 20:24'!
fileOutNameSpace
	self tag: 'name-space' do: [
		self tag: 'name' with: self environment.
		self tag: 'environment' with: 'Smalltalk'.
		self tag: 'private' with: 'false'.
		self tag: 'imports' do: [
			self nameSpaceImports do: [ :each |
				stream nextPutAll: 'private '; nextPutAll: each; nextPutAll: '.*'; cr ] ].
		self tag: 'category' with: self environment.
		self tag: 'attributes' do: [
			self tag: 'package' with: self environment ] ].! !

!MAVisualWorksExporter methodsFor: 'utilities' stamp: 'lr 11/15/2005 20:16'!
fullyQualifiedClassNameFor: aClass
	| position |
	ObjectRegistry at: aClass name ifPresent: [ :value | ^ value ].
	position := 1 max: (aClass name findFirst: [ :each | each isLowercase ]) - 2.
	^ String streamContents: [ :output |
		PrefixRegistry
			at: (aClass name copyFrom: 1 to: position) 
			ifPresent: [ :value | output nextPutAll: value; nextPut: $. ].
		output nextPutAll: aClass visualworksName ].! !

!MAVisualWorksExporter methodsFor: 'accessing' stamp: 'lr 11/15/2005 20:24'!
nameSpaceImports
	^ #( 'Smalltalk' 'Seaside' 'Magritte' ).! !

!MAVisualWorksExporter methodsFor: 'utilities' stamp: 'lr 11/15/2005 20:57'!
packageNameForMethod: aMethodReference
	^ (package includesClass: aMethodReference actualClass)
		ifTrue: [ self packageNameForClass: aMethodReference actualClass ]
		ifFalse: [ package externalName , '-Extensions' ].! !

!Behavior methodsFor: '*magritte-visualworks' stamp: 'lr 11/7/2005 18:16'!
visualworksName
	^ self name! !

!MADistribution class methodsFor: '*magritte-visualworks' stamp: 'lr 11/15/2005 20:42'!
fileOutForVisualWorks
	MAVisualWorksExporter fileOutPackageNamed: 'Magritte-Model'.
	MAVisualWorksExporter fileOutPackageNamed: 'Magritte-Tests'.
	MAVisualWorksExporter fileOutPackageNamed: 'Magritte-Seaside'.! !
MAVisualWorksExporter initialize!
